/*****************************************************************************\
* Copyright (c) 2003 Pelle Johansson.                                         *
* All rights reserved.                                                        *
*                                                                             *
* This file is part of the moftpd package. Use and distribution of            *
* this software is governed by the terms in the file LICENCE, which           *
* should have come with this package.                                         *
\*****************************************************************************/

/* $Id: utf8.h 686 2003-08-29 00:16:08Z morth $ */

#ifndef _UTF8_H
#define _UTF8_H

#include "table.h"

int valid_utf8 (const char *str);

const char *make_utf8 (const char *str, int force, int nfd);
char *unmake_utf8 (const char *str);

int read_utf8_char (const unsigned char **sp);
char *write_utf8_char (int ch, char *rp, int maxsize);

const char *convert_utf8_forward (const char *str, const int forwardTable[][6], int tabSize);
const char *convert_utf8_reverse (const char *str, const sized_table_t *reverseTable, int numSearch);

#endif /*_UTF8_H*/
